﻿// + ----------------------------------------------- ------------------- +
// | SPECIFIC PARAMETERS
// + ----------------------------------------------- ------------------- +
#property copyright ""; //Authorship
#property link ""; // Link to the developer's site
#property version ""; // Indicator version
#property description ""; // Indicator description
#property strict // Strict compilation mode
#property indicator_chart_window // Display the indicator in the chart window
#property indicator_buffers 5 // Number of buffers for indicator calculations
// + ----------------------------------------------- ------------------- +
// | SPECIFIC PARAMETERS
// + ----------------------------------------------- ------------------- +
// + ----------------------------------------------- ------------------- +
// | CUSTOM TRANSFERS
// + ----------------------------------------------- ------------------- +
// Enumeration of constants for the price type
enum PriceTypeInt
  {
   PRICE_CLOSE_1 = 0, // Closing price
   PRICE_OPEN_1 = 1, // Opening price
   PRICE_HIGH_1 = 2, // Maximum price for the period
   PRICE_LOW_1 = 3, // Lowest price for the period
   PRICE_MEDIAN_1 = 4, // Median price, (high + low) / 2
   PRICE_TYPICAL_1 = 5, // Typical price, (high + low + close) / 3
   PRICE_WEIGHTED_1 = 6 // Weighted closing price, (high + low + close + close) / 4
  };
/// Enumeration of constants instead of true / false
enum BoolInt
  {
   Yes = 0, // Yes
   No = 1 // No
  };
// Enumeration of line style constants
enum StyleLineInt
  {
   STYLE_SOLID_1 = 0, // Solid line
   STYLE_DASH_1 = 1, // Dashed line
   STYLE_DOT_1 = 2, // Dotted line
   STYLE_DASHDOT_1 = 3, // Dash-dotted line
   STYLE_DASHDOTDOT_1 = 4 // Dash-dotted line with double dots
  };
// Enumeration of constants for symbols
enum StyleArrowInt
  {
   STYLE_ARROW_1 = 217, // Symbol - upward fractal arrow
   STYLE_ARROW_2 = 218, // Symbol - downward fractal arrow
   STYLE_ARROW_3 = 221, // Symbol - an arrow in a circle up
   STYLE_ARROW_4 = 222, // Symbol - an arrow in a circle down
   STYLE_ARROW_5 = 221, // Symbol - thin up arrow
   STYLE_ARROW_6 = 222, // Symbol - thin arrow down
   STYLE_ARROW_7 = 233, // Symbol - thick arrow up
   STYLE_ARROW_8 = 234, // Symbol - thick down arrow
   STYLE_ARROW_9 = 83, // Symbol - drop
   STYLE_ARROW_10 = 84, // Symbol - snowflake
   STYLE_ARROW_11 = 251, // Symbol - cross
   STYLE_ARROW_12 = 252, // Symbol - check mark
   STYLE_ARROW_13 = 89, // Symbol - pintogram
   STYLE_ARROW_14 = 91, // Symbol - yyang
   STYLE_ARROW_15 = 161, // Symbol - circle
   STYLE_ARROW_16 = 164, // Symbol - a circle with a dot
   STYLE_ARROW_17 = 108, // Symbol is a big dot
   STYLE_ARROW_18 = 159, // Symbol - small dot
   STYLE_ARROW_19 = 110, // Symbol is a big square
   STYLE_ARROW_20 = 167, // Symbol - small square
   STYLE_ARROW_21 = 117, // Symbol - big rhombus
   STYLE_ARROW_22 = 119, // Symbol is a small diamond
   STYLE_ARROW_23 = 171, // Symbol is a star
   STYLE_ARROW_24 = 181 // Symbol - a star in a circle
  };
// + ----------------------------------------------- ------------------- +
// | CUSTOM TRANSFERS
// + ----------------------------------------------- ------------------- +
// + ----------------------------------------------- ------------------- +
// | INPUT SETTINGS
// + ----------------------------------------------- ------------------- +
extern ENUM_TIMEFRAMES TimeFrame = PERIOD_CURRENT; // Timeframe
extern int HalfLength = 20; //Period
extern PriceTypeInt Price = PRICE_WEIGHTED_1; // Candle close calculation
extern double BandsDeviations = 1.5; // Channel deviation
extern BoolInt Interpolate = No; // Interpolation
extern int History = 1500; // Limit history in bars
extern BoolInt alertsOn = No; // Allow alerts
extern BoolInt alertsOnCurrent = No; // Notifications "Yes" - on the current bar "No" - on the previous
extern BoolInt alertsOnHighLow = No; // Notifications of channel breakout "Yes" - High / Low "No" - Close
extern BoolInt alertsMessage = No; // Alert in the terminal
extern BoolInt alertsPush = No; // Push notification
extern BoolInt alertsEmail = No; // Email alert
extern string ChannelSetting = "Channel autobuilding settings"; // Channel autobuilding settings
extern BoolInt UseAutoChannel = No; // Use automatic channel settings
extern ENUM_TIMEFRAMES TimeM1 = PERIOD_M5; // Timeframe for plotting the channel on the M1 chart
extern ENUM_TIMEFRAMES TimeM5 = PERIOD_M15; // Timeframe for plotting the channel on the M5 chart
extern ENUM_TIMEFRAMES TimeM15 = PERIOD_M30; // Timeframe for plotting the channel on the M15 chart
extern ENUM_TIMEFRAMES TimeM30 = PERIOD_H1; // Timeframe for plotting the channel on the M30 chart
extern ENUM_TIMEFRAMES TimeH1 = PERIOD_H4; // Timeframe for building the channel on the H1 chart
extern ENUM_TIMEFRAMES TimeH4 = PERIOD_D1; // Timeframe for building the channel on the H4 chart
extern ENUM_TIMEFRAMES TimeD1 = PERIOD_W1; // Timeframe for plotting the channel on the D1 chart
extern string ChannelStyle = "Channel and arrow style settings"; // Channel and arrow style settings
extern color ColUpLine = clrOrange; // Color of the upper line of the channel
extern StyleLineInt StyleUpLine = STYLE_SOLID_1; // Style of the top line of the channel
extern int WidthUpLine = 0; // Thickness of the top line of the channel
extern color ColMidLine = clrNONE; // Color of the middle line of the channel
extern StyleLineInt StyleMidLine = STYLE_DOT_1; // The style of the middle line of the channel
extern int WidthMidLine = 0; // Thickness of the middle line of the channel
extern color ColDnLine = clrLime; // Color of the bottom line of the channel
extern StyleLineInt StyleDnLine = STYLE_SOLID_1; // Style of the bottom line of the channel
extern int WidthDnLine = 0; // Thickness of the bottom line of the channel
extern color ColUpArrow = clrOrange; // Color of top characters
extern StyleArrowInt StylUpArrow = STYLE_ARROW_18; // Style of upper characters
extern int WidthUpArrow = 0; // Thickness of top characters
extern color ColDnArrow = clrLime; // Color of bottom symbols
extern StyleArrowInt StylDnArrow = STYLE_ARROW_18; // Style of bottom characters
extern int WidthDnArrow = 0; // Thickness of bottom symbols
extern int                btn_Subwindow = 0;
extern ENUM_BASE_CORNER   btn_corner            = CORNER_LEFT_UPPER; 
extern string             btn_text              = "tma";
extern string             btn_Font              = "Arial";
extern int                btn_FontSize          = 8;                        
extern color              btn_text_ON_color     = clrLime;
extern color              btn_text_OFF_color    = clrRed;
extern color              btn_background_color  = clrDimGray;
extern color              btn_border_color      = clrBlack;
extern int                button_x              = 900;                                   
extern int                button_y              = 20;                                   
//extern int                btn_Width             = 60;                                
//extern int                btn_Height            = 20;                               
string IndicatorName, IndicatorObjPrefix,buttonId;
bool show_data = true;
bool recalc    = true;
// + ----------------------------------------------- ------------------- +
// | INPUT SETTINGS
// + ----------------------------------------------- ------------------- +
// + ----------------------------------------------- ------------------- +
// | INTERNAL GLOBAL VARIABLES
// + ----------------------------------------------- ------------------- +
double Average [];
double TopLine [];
double LowerLine [];
double MediumUp [];
double MediumDn [];
double UpArrow [];
double DnArrow [];
double time_alert [];
string NameInd;
bool Calc = false;
bool NoCalc = false;
ENUM_TIMEFRAMES TF;
ENUM_APPLIED_PRICE price;
// + ----------------------------------------------- ------------------- +
// | INTERNAL GLOBAL VARIABLES
// + ----------------------------------------------- ------------------- +
// + ----------------------------------------------- ------------------- +
// | INITIAL INITIALIZATION
// + ----------------------------------------------- ------------------- +
string GenerateIndicatorName(const string target) 
{
   string name = target;
   int try = 2;
   while (WindowFind(name) != -1)
   {
      name = target + " #" + IntegerToString(try++);
   }
   return name;
}

int OnInit ()
  {
   IndicatorName = GenerateIndicatorName(btn_text);
   IndicatorObjPrefix = "__" + IndicatorName + "__";
   IndicatorShortName(IndicatorName);
   IndicatorDigits(Digits);
   
   double val;
   if (GlobalVariableGet(IndicatorName + "_visibility", val))
      show_data = val != 0;
      
   // Convert the price type
   if (Price == PRICE_CLOSE_1) price = 0;
   if (Price == PRICE_OPEN_1) price = 1;
   if (Price == PRICE_HIGH_1) price = 2;
   if (Price == PRICE_LOW_1) price = 3;
   if (Price == PRICE_MEDIAN_1) price = 4;
   if (Price == PRICE_TYPICAL_1) price = 5;
   if (Price == PRICE_WEIGHTED_1) price = 6;
   // Determination of the calculated timeframe
   // if the channel auto-tuning mode is enabled
   if (UseAutoChannel == Yes)
     {
      if (_Period == PERIOD_M1) TF = PERIOD_M5;
      if (_Period == PERIOD_M5) TF = PERIOD_M15;
      if (_Period == PERIOD_M15) TF = PERIOD_M30;
      if (_Period == PERIOD_M30) TF = PERIOD_H1;
      if (_Period == PERIOD_H1) TF = PERIOD_H4;
      if (_Period == PERIOD_H4) TF = PERIOD_D1;
      if (_Period == PERIOD_D1) TF = PERIOD_W1;
     }
   // otherwise we take the specified timeframe
   else TF = TimeFrame;
   // We insure against the zero value of the period
   HalfLength = MathMax (HalfLength, 1);
   // Initialization and setting of indicator buffers
   IndicatorBuffers (7);
   SetIndexBuffer (0, Average);
   SetIndexDrawBegin (0, HalfLength);
   SetIndexStyle (0, DRAW_LINE, StyleMidLine, WidthMidLine, ColMidLine);
   SetIndexBuffer (1, TopLine);
   SetIndexDrawBegin (1, HalfLength);
   SetIndexStyle (1, DRAW_LINE, StyleUpLine, WidthUpLine, ColUpLine);
   SetIndexBuffer (2, LowerLine);
   SetIndexDrawBegin (2, HalfLength);
   SetIndexStyle (2, DRAW_LINE, StyleDnLine, WidthDnLine, ColDnLine);
   SetIndexBuffer (3, DnArrow);
   SetIndexStyle (3, DRAW_ARROW, EMPTY, WidthUpArrow, ColDnArrow);
   SetIndexArrow (3, StylDnArrow);
   SetIndexBuffer (4, UpArrow);
   SetIndexStyle (4, DRAW_ARROW, EMPTY, WidthDnArrow, ColUpArrow);
   SetIndexArrow (4, StylUpArrow);
   SetIndexBuffer (5, MediumUp);
   SetIndexBuffer (6, MediumDn);
   // Turn on the flag for calculating the main function
   if (ChannelSetting == "Calculate")
     {
      Calc = true;
      return (INIT_SUCCEEDED);
     }
   // Turn on the start bar override flag for a higher timeframe
   if (ChannelSetting == "NoCalculate")
     {
      NoCalc = true;
      return (INIT_SUCCEEDED);
     }
   // Get the indicator name
   NameInd = MQLInfoString (MQL_PROGRAM_NAME);
   
     ChartSetInteger(0, CHART_EVENT_MOUSE_MOVE, 1);
   buttonId = IndicatorObjPrefix + (btn_text);
   createButton(buttonId, btn_text, 60, 20, btn_Font, btn_FontSize, btn_background_color, btn_border_color, btn_text_ON_color);
   ObjectSetInteger(0, buttonId, OBJPROP_YDISTANCE, button_y);
   ObjectSetInteger(0, buttonId, OBJPROP_XDISTANCE, button_x);
   return (INIT_SUCCEEDED);
  }
  void OnDeinit(const int reason)

{ 
ObjectsDeleteAll(ChartID(), IndicatorObjPrefix);

  }
  
  void createButton(string buttonID,string buttonText,int width,int height,string font,int fontSize,color bgColor,color borderColor,color txtColor)
{
      ObjectDelete    (0,buttonID);
      ObjectCreate (0,buttonID,OBJ_BUTTON,btn_Subwindow,0,0);
      ObjectSetInteger(0,buttonID,OBJPROP_COLOR,txtColor);
      ObjectSetInteger(0,buttonID,OBJPROP_BGCOLOR,bgColor);
      ObjectSetInteger(0,buttonID,OBJPROP_BORDER_COLOR,borderColor);
      ObjectSetInteger(0,buttonID,OBJPROP_BORDER_TYPE,BORDER_RAISED);
      ObjectSetInteger(0,buttonID,OBJPROP_XSIZE,width);
      ObjectSetInteger(0,buttonID,OBJPROP_YSIZE,height);
      ObjectSetString (0,buttonID,OBJPROP_FONT,font);
      ObjectSetString (0,buttonID,OBJPROP_TEXT,buttonText);
      ObjectSetInteger(0,buttonID,OBJPROP_FONTSIZE,fontSize);
      ObjectSetInteger(0,buttonID,OBJPROP_SELECTABLE,0);
      ObjectSetInteger(0,buttonID,OBJPROP_CORNER,btn_corner);
      ObjectSetInteger(0,buttonID,OBJPROP_HIDDEN,1);
      ObjectSetInteger(0,buttonID,OBJPROP_XDISTANCE,9999);
      ObjectSetInteger(0,buttonID,OBJPROP_YDISTANCE,9999);
}
//+------------------------------------------------------------------+
void handleButtonClicks()
{
   if (ObjectGetInteger(0, buttonId, OBJPROP_STATE))
   {
      ObjectSetInteger(0, buttonId, OBJPROP_STATE, false);
      show_data = !show_data;
      GlobalVariableSet(IndicatorName + "_visibility", show_data ? 1.0 : 0.0);
      recalc = true;
     // start();
   }
}
//+------------------------------------------------------------------+
void OnChartEvent(const int id, 
                  const long &lparam,
                  const double &dparam,
                  const string &sparam)
{
   

   
   
   handleButtonClicks();
   if (id==CHARTEVENT_OBJECT_CLICK && ObjectGet(sparam,OBJPROP_TYPE)==OBJ_BUTTON)
   
   
   
   SetIndexDrawBegin (0, HalfLength);
   SetIndexStyle (0, DRAW_LINE, StyleMidLine, WidthMidLine, ColMidLine);
 
   SetIndexDrawBegin (1, HalfLength);
   SetIndexStyle (1, DRAW_LINE, StyleUpLine, WidthUpLine, ColUpLine);
  
   SetIndexDrawBegin (2, HalfLength);
   SetIndexStyle (2, DRAW_LINE, StyleDnLine, WidthDnLine, ColDnLine);
 
   SetIndexStyle (3, DRAW_ARROW, EMPTY, WidthUpArrow, ColDnArrow);
   SetIndexArrow (3, StylDnArrow);
  
   SetIndexStyle (4, DRAW_ARROW, EMPTY, WidthDnArrow, ColUpArrow);
   
   if (show_data)
   {
   ObjectSetInteger(ChartID(),buttonId,OBJPROP_COLOR,btn_text_ON_color);
     
      }
      else
      {
        ObjectSetInteger(ChartID(),buttonId,OBJPROP_COLOR,btn_text_OFF_color);
        for (int banzai=0; banzai<indicator_buffers; banzai++)
            SetIndexStyle(banzai,DRAW_NONE);
      } 

     }
         
   


// + ----------------------------------------------- ------------------- +
// | INITIAL INITIALIZATION
// + ----------------------------------------------- ------------------- +
// + ----------------------------------------------- ------------------- +
// | INDICATOR BODY
// + ----------------------------------------------- ------------------- +
int OnCalculate (const int rates_total, // Number of bars on the current tick
                const int prev_calculated, // Number of closed bars
                const datetime & time [], // Array of time of each bar in history
                const double & open [], // Array of open prices of each bar in history
                const double & high [], // Array of the highs of each bar in history
                const double & low [], // Array of lows of each bar in history
                const double & close [], // Array of closing prices of each bar in history
                const long & tick_volume [], // Array of volume in ticks of each bar in history
                const long & volume [], // Array of the real volume of each bar in history
                const int & spread []) // Array of the spread of each bar in history
  {
   // Declare internal variables
   int i, k, n, limit, forBar, Shift, timeBar;
   datetime TimeBar;
   double factor, ZeroBarUP, ZeroBarDN, PreviousBarUP, PreviousBarDN, ZeroH, PreviousH, ZeroL, PreviousL, Close0, Close1;
   // Defining the start bar for calculation
   if(History != 0) limit = History;
   else limit = rates_total - 2;
   // Checking the flag of redefining the start bar for a higher timeframe
   if (NoCalc)
     {
      Average [0] = limit;
      return (rates_total);
     }
   // Checking the flag for calculating the main function
   if (Calc)
     {
      Calculate (limit);
      return (rates_total);
     }
   // If the calculated timeframe is greater than the current period, then redefine the start bar
   if (TF> _Period) limit = MathMax (limit, MathMin (limit - 1, (int) iCustom (NULL, TF, NameInd, PERIOD_CURRENT, HalfLength, Price, BandsDeviations, Interpolate,
                                                                                       History, alertsOn, alertsOnCurrent, alertsOnHighLow, alertsMessage,
                                                                                       alertsPush, alertsEmail, "NoCalculate", UseAutoChannel,
                                                                                       TimeM1, TimeM5, TimeM15, TimeM30, TimeH1, TimeH4, TimeD1,0,0) * TF / _Period));
   // Cycle of indicator calculation
   for(i = limit; i >= 0; i--)
     {
      Shift = iBarShift (NULL, TF, Time [i]);
      TimeBar = iTime (NULL, TF, Shift);
      Average [i] = iCustom (NULL, TF, NameInd, PERIOD_CURRENT, HalfLength, Price, BandsDeviations, Interpolate,
                                                             History, alertsOn, alertsOnCurrent, alertsOnHighLow, alertsMessage,
                                                             alertsPush, alertsEmail, "Calculate", UseAutoChannel,
                                                             TimeM1, TimeM5, TimeM15, TimeM30, TimeH1, TimeH4, TimeD1,0, Shift);
      TopLine [i] = iCustom (NULL, TF, NameInd, PERIOD_CURRENT, HalfLength, Price, BandsDeviations, Interpolate,
                                                             History, alertsOn, alertsOnCurrent, alertsOnHighLow, alertsMessage,
                                                             alertsPush, alertsEmail, "Calculate", UseAutoChannel,
                                                             TimeM1, TimeM5, TimeM15, TimeM30, TimeH1, TimeH4, TimeD1,1, Shift);
	LowerLine [i] = iCustom (NULL, TF, NameInd, PERIOD_CURRENT, HalfLength, Price, BandsDeviations, Interpolate,
                                                             History, alertsOn, alertsOnCurrent, alertsOnHighLow, alertsMessage,
                                                             alertsPush, alertsEmail, "Calculate", UseAutoChannel,
                                                             TimeM1, TimeM5, TimeM15, TimeM30, TimeH1, TimeH4, TimeD1,2, Shift);
      UpArrow [i] = EMPTY_VALUE;
      DnArrow [i] = EMPTY_VALUE;
      // Calculate the value of the upper and lower symbols by ATR
      if(High[i+1] > TopLine[i+1] && Close[i+1] > Open[i+1] && Close[i] < Open[i]) UpArrow[i] = High[i] + iATR(NULL,0,20,i);
      if(Low[i+1] < LowerLine[i+1] && Close[i+1] < Open[i+1] && Close[i] > Open[i]) DnArrow[i] = High[i] - iATR(NULL,0,20,i);
      // If channel smoothing is enabled
      if (Interpolate == Yes)
        {
         // Let's calculate the last bar taking into account the weight coefficients for smoothing the channel lines
         for(n = 1; i+n < limit && Time[i+n] >= TimeBar; n++) continue;
         factor = 1.0 / n;
         for (k = 1; k <n; k ++)
           {
            Average [i + k] = k * factor * Average [i + n] + (1.0 - k * factor) * Average [i];
            TopLine [i + k] = k * factor * TopLine [i + n] + (1.0 - k * factor) * TopLine [i];
            LowerLine [i + k] = k * factor * LowerLine [i + n] + (1.0 - k * factor) * LowerLine [i];
           }
        }
     }
   // Determine the moment of notifications
   // If notifications are allowed
   if (alertsOn == Yes)
     {
      // If notifications on the current bar are allowed, then we take the current bar
      if (alertsOnCurrent == Yes) forBar = 0;
      // otherwise previous
      else forBar = 1;
      timeBar = iBarShift (NULL, 0, iTime (NULL, TF, forBar));
      ZeroBarUP = iCustom (NULL, TF, NameInd, PERIOD_CURRENT, HalfLength, Price, BandsDeviations, Interpolate,
                                                             History, alertsOn, alertsOnCurrent, alertsOnHighLow, alertsMessage,
                                                             alertsPush, alertsEmail, "Calculate", UseAutoChannel,
                                                             TimeM1, TimeM5, TimeM15, TimeM30, TimeH1, TimeH4, TimeD1,1, forBar);
      ZeroBarDN = iCustom (NULL, TF, NameInd, PERIOD_CURRENT, HalfLength, Price, BandsDeviations, Interpolate,
                                                             History, alertsOn, alertsOnCurrent, alertsOnHighLow, alertsMessage,
                                                             alertsPush, alertsEmail, "Calculate", UseAutoChannel,
                                                             TimeM1, TimeM5, TimeM15, TimeM30, TimeH1, TimeH4, TimeD1,2, forBar);
      PreviousBarUP = iCustom (NULL, TF, NameInd, PERIOD_CURRENT, HalfLength, Price, BandsDeviations, Interpolate,
                                                             History, alertsOn, alertsOnCurrent, alertsOnHighLow, alertsMessage,
                                                             alertsPush, alertsEmail, "Calculate", UseAutoChannel,
                                                             TimeM1, TimeM5, TimeM15, TimeM30, TimeH1, TimeH4, TimeD1,1, forBar + 1);
      PreviousBarDN = iCustom (NULL, TF, NameInd, PERIOD_CURRENT, HalfLength, Price, BandsDeviations, Interpolate,
                                                             History, alertsOn, alertsOnCurrent, alertsOnHighLow, alertsMessage,
                                                             alertsPush, alertsEmail, "Calculate", UseAutoChannel,
                                                             TimeM1, TimeM5, TimeM15, TimeM30, TimeH1, TimeH4, TimeD1,2, forBar + 1);
      // If notifications of breaking through the channel boundaries are allowed
      if (alertsOnHighLow == Yes)
        {
         ZeroH = iHigh (NULL, TF, forBar);
         PreviousH = iHigh (NULL, TF, forBar + 1);
         ZeroL = iLow (NULL, TF, forBar);
         PreviousL = iLow (NULL, TF, forBar + 1);
         if (ZeroH> ZeroBarUP && PreviousH <PreviousBarUP) doAlert (timeBar, "Breaking through the upper border of the channel");
         if (ZeroL <ZeroBarDN && PreviousL> PreviousBarDN) doAlert (timeBar, "Breaking through the lower border of the channel");
        }
      //otherwise
      else
        {
         Close0 = iClose (NULL, TF, forBar);
         Close1 = iClose (NULL, TF, forBar + 1);
         if (Close0> ZeroBarUP && Close1 <PreviousBarUP) doAlert (timeBar, "Closing the candle above the upper border of the channel");
         if (Close0 <ZeroBarDN && Close1> PreviousBarDN) doAlert (timeBar, "Closing of the candle below the lower border of the channel");
        }
     }
   return (rates_total);
  }
// + ----------------------------------------------- ------------------- +
// | INDICATOR BODY
// + ----------------------------------------------- ------------------- +
// + ----------------------------------------------- ------------------- +
// | MAIN CALCULATION FUNCTION
// + ----------------------------------------------- ------------------- +
void Calculate (int limit)
  {
   // Declare internal variables
   int i, j, k;
double FullLength = 2 * HalfLength + 1;
   double sum, sumw, diff;
   // Calculation cycle
   for(i = limit; i >= 0; i--)
     {
      // Calculate the middle line of the channel
      sum = (HalfLength + 1) * iMA (NULL, 0,1,0, MODE_SMA, price, i);
      sumw = (HalfLength + 1);
      for (j = 1, k = HalfLength; j <= HalfLength; j ++, k--)
        {
         sum  += k * iMA(NULL,0,1,0,MODE_SMA,price,i+j);
         sumw += k;
         if(j <= i)
           {
            sum  += k * iMA(NULL,0,1,0,MODE_SMA,price,i-j);
            sumw += k;
           }
        }
      Average[i] = sum / sumw;
      Average [i] = sum / sumw;
      // Calculation of the upper and lower channel lines
      diff = iMA (NULL, 0,1,0, MODE_SMA, price, i) - Average [i];
      if (i> (limit - HalfLength - 1)) continue;
      if (i == (limit - HalfLength - 1))
        {
         TopLine [i] = Average [i];
         LowerLine [i] = Average [i];
         if(diff >= 0)
           {
            MediumUp [i] = MathPow (diff, 2);
            MediumDn [i] = 0;
           }
         else
           {
            MediumDn [i] = MathPow (diff, 2);
            MediumUp [i] = 0;
           }
         continue;
        }
      if(diff >= 0)
        {
         MediumUp [i] = (MediumUp [i + 1] * (FullLength - 1) + MathPow (diff, 2)) / FullLength;
         MediumDn [i] = MediumDn [i + 1] * (FullLength - 1) / FullLength;
        }
      else
        {
         MediumDn [i] = (MediumDn [i + 1] * (FullLength - 1) + MathPow (diff, 2)) / FullLength;
         MediumUp [i] = MediumUp [i + 1] * (FullLength - 1) / FullLength;
        }
      TopLine [i] = Average [i] + BandsDeviations * MathSqrt (MediumUp [i]);
      LowerLine [i] = Average [i] - BandsDeviations * MathSqrt (MediumDn [i]);
     }
  }
// + ----------------------------------------------- ------------------- +
// | MAIN CALCULATION FUNCTION
// + ----------------------------------------------- ------------------- +
// + ----------------------------------------------- ------------------- +
// | ALERT FUNCTION
// + ----------------------------------------------- ------------------- +
void doAlert(int forBar, string doWhat)
  {
   static string   previousAlert = "";
   static datetime previousTime;
   string message;

   if(previousAlert != doWhat || previousTime != Time[forBar])
     {
      previousAlert = doWhat;
      previousTime  = Time[forBar];
      message = StringConcatenate(_Symbol," в ",TimeToStr(TimeLocal(),TIME_SECONDS)," ",NameInd," : ",doWhat);
      if(alertsMessage == Yes) Alert(message);
      if(alertsEmail == Yes) SendMail(StringConcatenate(_Symbol,NameInd," "),message);
      if(alertsPush == Yes) SendNotification(message);
     }
  }
// + ----------------------------------------------- ------------------- +
// | ALERT FUNCTION
// + ----------------------------------------------- ------------------- +
